#include <bits/stdc++.h>
using namespace std;

struct hrana { int dest, len, nxt; };
ostream& operator<< (ostream& out, const hrana &e) { return out << "(" << e.dest << "@" << e.len << ")"; }

int n, q, u, v, f;
vector<hrana> G;
vector<int> prva_hrana;
vector<int> realna_farba(n);

void pridaj_hranu(int src, int dest, int len) {
    int id = G.size();
    G.push_back( {dest, len, prva_hrana[src]} );
    prva_hrana[src] = id;
}

void prefarbi(int x, int y) {
    int rx = realna_farba[x], ry = realna_farba[y];
    if (rx == -1) return;
   
    int rz = f++;
    //cout << "prefarbujem " << rx << " na " << ry << " nova farba oboch " << rz << endl;
    realna_farba[x] = -1;
    realna_farba[y] = rz;

    pridaj_hranu(n+2*rx, n+2*rz, 0);
    pridaj_hranu(n+2*rz+1, n+2*rx+1, 0);

    if (ry != -1) {
        pridaj_hranu(n+2*ry, n+2*rz, 0);
        pridaj_hranu(n+2*rz+1, n+2*ry+1, 0);
    }
}

void spoj(int x, int y) {
    int rx = realna_farba[x], ry = realna_farba[y];
    //cout << "spajam hranou farby " << rx << " " << ry << endl;
    if (rx == -1 || ry == -1) return;
    pridaj_hranu(n+2*rx, n+2*ry+1, 1);
    pridaj_hranu(n+2*ry, n+2*rx+1, 1);
}

int bfs() {
    int nn = n + 2*f;
    vector<int> vzdialenost(nn, nn+47);
    vzdialenost[u] = 0;
    deque<int> Q;
    Q.push_back(u);
    while (!Q.empty()) {
        int kde = Q.front();
        Q.pop_front();
        int eid = prva_hrana[kde];
        while (eid != -1) {
            hrana e = G[eid];
            eid = e.nxt;
            int kam = e.dest, vzd = vzdialenost[kde] + e.len;
            if (vzdialenost[kam] <= vzd) continue;
            vzdialenost[kam] = vzd;
            if (e.len) Q.push_back(kam); else Q.push_front(kam);
        }
    }
    assert( vzdialenost[v] != nn+47 );
    return vzdialenost[v];
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> q >> u >> v;
    G.reserve(2*n + 4*q + 7);
    prva_hrana.resize(3*n + 2*q + 7, -1);
    f = n;
    realna_farba.resize(n);
    for (int i=0; i<n; ++i) {
        realna_farba[i] = i;
        pridaj_hranu(i, n+2*i, 0);
        pridaj_hranu(n+2*i+1, i, 0);
    }
    for (int qi=0; qi<q; ++qi) {
        string cmd; 
        int x, y;
        cin >> cmd >> x >> y;
        if (cmd == "p") prefarbi(x,y); else spoj(x,y);
    }
    cout << bfs() << endl;
}
